﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace XamNumericEditor_Ex
{
	public class UserViewModel : ObservableObject, IDataErrorInfo
    {
        private User user;

        public UserViewModel()  { }

        public UserViewModel(User u)
        {
            user = u;
        }

        
		public double Frequency
		{
            get { return user.Frequency; }
			set
			{
				user.Frequency = value;
				NotifyPropertyChanged("Frequency");
			}
		}
		public double Frequency1
		{
			get { return user.Frequency1; }
			set
			{
				user.Frequency1 = value;
				NotifyPropertyChanged("Frequency1");
			}
		}
		public double Frequency2
		{
			get { return user.Frequency2; }
			set
			{
				user.Frequency2 = value;
				NotifyPropertyChanged("Frequency2");
			}
		}
        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }


		#region IDataErrorInfo Members

		public string Error
		{
			get { throw new NotImplementedException(); }
		}

		public override bool IsValid()
		{
			bool result = true;
			IsValidating = true;
			OnPropertyChanged(() => Frequency1);
			
			if (ErrorsFound.Any())
			{
				result = false;
			}
			IsValidating = false;
			return result;
		}

		public string this[string columnName]
		{
			get
			{
				string result = string.Empty;
				if (!IsValidating)
					return result;
				ErrorsFound.Remove(columnName);
				switch (columnName)
				{


					case "Frequency1":
						if (Frequency1 < 0.000001 || Frequency1 > 1000000)
						{
							result = "Message_AllowedRange";
							ErrorsFound.Add(columnName, result);
						}
						break;

				}
				return result;
			}
		}
		#endregion
    }
}
